import java.io.BufferedReader;
import java.io.FileReader;

/**parses the xml-file**/
public class Parser {
  
  private String filename;
  
  public Parser(String filename){
    this.filename = filename;
  }
  
  public Exception parse(){
    int statenumber=1;
    try {
      BufferedReader in = new BufferedReader(new FileReader(filename));
      String line = null;
      State s;
      Transition t;
      boolean isumlsm = false;
      //StateDiagramm leeren
      StateDiagram.getIntance().dump();
      while ((line = in.readLine()) != null) {
        if (line.contains("<UmlStateMachine")){ //first line should contain this string
          isumlsm = true;
        }
        if (line.contains("<UmlPseudoState")||line.contains("<UmlSimpleState")) { //a new state is found
          s = new State(); //so create a new state object
          s.setName(line.substring(line.indexOf("name=\"")+6, line.indexOf("\"", line.indexOf("name=\"")+6))); //sets the states name
          s.setId(Integer.parseInt(line.substring(line.indexOf("id=\"")+4, line.indexOf("\"", line.indexOf("id=\"")+4)))); //sets the states id
          s.setCodeid(statenumber); //each state gets a number from 1 to n
          statenumber+=1; //increase that number for the next state
          line = in.readLine();
          while ( (!line.contains("</UmlPseudoState>") ) && (!line.contains("</UmlSimpleState>") ) ) { //check all attributes of the state
            if (line.contains("<Attribute name=\"outgoing\">")) { //only outgoing transitions are considered
              line = in.readLine();
              while (!line.contains("</Attribute>")) { //all outgoing transitions are stored
                s.getTransitions_out().add(Integer.parseInt(line.substring(line.indexOf("#")+1, line.indexOf("\"", line.indexOf("#")))));
                line = in.readLine();
              }
            }            
            line = in.readLine();
          }
          StateDiagram.getIntance().getStates().add(s); //the state is added to the diagram
          s=null;
        }
        
        if (line.contains("<UmlTransition")) { //a new transition is found
          t = new Transition(); //so a new transition object is created
          t.setName(line.substring(line.indexOf("name=\"")+6, line.indexOf("\"", line.indexOf("name=\"")+6))); //sets the name of the transition
          t.setId(Integer.parseInt(line.substring(line.indexOf("id=\"")+4, line.indexOf("\"", line.indexOf("id=\"")+4)))); //sets the id
          line = in.readLine();
          while(!line.contains("</UmlTransition>")) { //check all attributes of that transition
            if (line.contains("name=\"start\"")){
              t.setStart(StateDiagram.getIntance().getStatebyId(Integer.parseInt(line.substring(line.indexOf("#")+1, line.indexOf("\"", line.indexOf("#"))))));
            }
            if (line.contains("name=\"end\"")){
              t.setEnd(StateDiagram.getIntance().getStatebyId(Integer.parseInt(line.substring(line.indexOf("#")+1, line.indexOf("\"", line.indexOf("#"))))));
            }
            if (line.contains("name=\"trigger\"")){
              t.setTrigger(line.substring(line.indexOf(">")+1, line.indexOf("<", line.indexOf(">"))));
            }
            if (line.contains("name=\"effect\"")){
              t.setEffect(line.substring(line.indexOf(">")+1, line.indexOf("<", line.indexOf(">"))));
            }
            if (line.contains("name=\"guard\"")){
              String tmp =line.substring(line.indexOf(">")+1, line.indexOf("<", line.indexOf(">")));
              tmp=tmp.replace("OR", "||"); //the string OR is replaced with the string || so that ruable arduino code can be created
              tmp=tmp.replace("&gt;", ">");//the string &gt is replaced with the string > so that ruable arduino code can be created
              t.setGuard(tmp);
            }
            line = in.readLine();
          }
          StateDiagram.getIntance().getTransitions().add(t); //the transition is added to the diagram
          t=null;
        }
      }
      if (isumlsm==false){ //read xml-file seems not to be a uml state diagram
        throw new NotUmlException();
      }
    } catch (Exception e) {
      return e;
    }
    return null;
  }

}